/* CPUID Declaration */
void cpuid_func(int fn, unsigned int reg[4]);

/* Registers */
#define EAX 0
#define EBX 1
#define ECX 2
#define EDX 3

/* CPUID Functions */
#define CPUID_VENDORID 0x00000000
#define CPUID_PROCINFO 0x00000001
#define CPUID_CACHETLB 0x00000002
#define CPUID_PROCSRNO 0x00000003
#define CPUID_CACHINFO 0x00000004
#define CPUID_MONINFO  0x00000005
#define CPUID_PWRINFO  0x00000006
#define CPUID_DCAINFO  0x00000009
#define CPUID_PEMOINFO 0x0000000a
#define CPUID_TOPOINFO 0x0000000b

/* Extended CPUID Functions */
#define CPUID_HEXTFUNC 0x80000000
#define CPUID_EPROINFO 0x80000001
#define CPUID_PRBRSTR1 0x80000002
#define CPUID_PRBRSTR2 0x80000003
#define CPUID_PRBRSTR3 0x80000004
#define CPUID_L1INFO   0x80000005
#define CPUID_L2L3INFO 0x80000006
#define CPUID_EPMINFO  0x80000007
#define CPUID_MISCINFO 0x80000008
#define CPUID_SVMINFO  0x8000000a
#define CPUID_TLBCFG   0x80000019
#define CPUID_PFOPTID  0x8000001a

/* Flags for every function */

/* CPU_PROCINFO */
#define CPU_EDX_MMX      0x00800000
#define CPU_EDX_SSE      0x02000000
#define CPU_EDX_SSE2     0x04000000
#define CPU_EDX_FXSAVE   0x01000000
#define CPU_EDX_CMOV     0x00008000
#define CPU_EDX_HT       0x10000000
#define CPU_EDX_CX8B     0x00000100
#define CPU_ECX_SSE3     0x00000001
#define CPU_ECX_SSSE3    0x00000200
#define CPU_ECX_SSE41    0x00080000
#define CPU_ECX_SSE42    0x00100000
#define CPU_ECX_CX16B    0x00002000
#define CPU_ECX_POPCNT   0x00800000

/* CPU_EPROINFO */
#define CPU_EDX_AMDMMX   0x00800000
#define CPU_EDX_3DN      0x80000000
#define CPU_EDX_E3DN     0x40000000
#define CPU_EDX_LM       0x20000000
#define CPU_ECX_SSE4A    0x00000080
#define CPU_ECX_SSE5A    0x00000800
#define CPU_ECX_LAHF_LM  0x00000001
